/* 
 * Auth: Christian Hansen (chansen@cs.umd.edu)
 *       University of Maryland, College Park
 * Desc: Functionality for manipulating irregular block decompositions.
 *       This code was adapted in part from Jae-Yong Lee's Meta-Chaos work.
 */

#ifndef BIRREG_H
#define BIRREG_H

#include "multiblockparti.h"

decomp_block_t* alloc_block(int);
void free_block(decomp_block_t*);
void print_block(decomp_block_t*, int, char*);
int store_tree(decomp_tree_t*, decomp_block_t**, int);
void free_tree(decomp_tree_t*);
int count_tree(decomp_tree_t*);
void print_tree(decomp_tree_t*, int, char*);
void free_decomp(parti_decomp_t*);
int count_decomp(parti_decomp_t*);
void store_decomp(parti_decomp_t*, decomp_block_t**);
void print_decomp(parti_decomp_t*);
void get_task_blocks(int, decomp_tree_t*, decomp_block_t***, int*);
void get_region_blocks(parti_region_t*, decomp_tree_t*, decomp_block_t***, int*);
void print_darray(parti_darray_t*);

#endif /* BIRREG_H */
