/* 
 * Auth: Alan Sussman (als@cs.umd.edu)
 *       University of Maryland, College Park
 * Desc: 
 */

#ifndef HASH_H
#define HASH_H

#include "bsparti.h"

int insert_sch_table(SCHED*);
void remove_sch_table(SCHED*);
SCHED* lookupsch(int);

int insert_da_table(DARRAY*);
DARRAY* lookupda(int);

int insert_decomp_table(DECOMP*);
DECOMP* lookupdecomp(int);

int insert_vproc_table(VPROC*);
VPROC* lookupvproc(int);

void insert_exch_table(SCHED*, DARRAY*, int, int*);
void delete_exch_table(SCHED*);
void clear_exch_table(DARRAY*);
SCHED* lookup_exch(DARRAY*, int, int*);
void destroy_exch_table();

void insert_sub_table(SCHED*, DARRAY*, DARRAY*, int, int*, int*, int*, int*, int*, int*, int*, int*);
void delete_sub_table(SCHED*);
void clear_sub_table(DARRAY*);
SCHED* lookup_sub(DARRAY*, DARRAY*, int, int*, int*, int*, int*, int*, int*, int*, int*);
void destroy_sub_table();

void destroy_sch_table();
void destroy_da_table();
void destroy_decomp_table();
void destroy_vproc_table();

void cleanup_da_table();
void cleanup_subarray_table();
void cleanup_exch_table();

#endif /* HASH_H */
