/* src/port.h.  Generated by configure.  */
/*
 * Auth: Alan Sussman (als@cs.umd.edu)
 *       University of Maryland, College Park
 * Desc:
 */

#ifndef PORT_H
#define PORT_H

#define USE_MPI 1
/* #undef USE_PVM */

/*
 * MPI
 */
#ifdef USE_MPI
#include <mpi.h>
extern MPI_Comm GROUPCOMM;

#define GID_TYPE                           MPI_Request
#define PARTI_setup(grp)                   PARTI_MPI_setup(grp)
#define PARTI_cleanup()                    PARTI_MPI_cleanup()
#define PARTI_numprocs()                   PARTI_MPI_numprocs()
#define PARTI_myproc()                     PARTI_MPI_myproc()
#define PARTI_killall()                    PARTI_MPI_killall()
#define PARTI_csend(tag,buf,len,node)      PARTI_MPI_csend(tag,buf,len,node)
#define PARTI_crecv(tag,buf,len,node)      PARTI_MPI_crecv(tag,buf,len,node)
#define PARTI_isend(tag,buf,len,node,gid)  PARTI_MPI_isend(tag,buf,len,node,gid)
#define PARTI_irecv(tag,buf,len,node,gid)  PARTI_MPI_irecv(tag,buf,len,node,gid)
#define PARTI_msgdone(gid)                 PARTI_MPI_msgdone(gid)
#define PARTI_msgwait(gid)                 PARTI_MPI_msgwait(gid)
#define PARTI_gsync()                      PARTI_MPI_gsync()

int PARTI_MPI_setup(MPI_Comm*);
void PARTI_MPI_cleanup();
int PARTI_MPI_numprocs();
int PARTI_MPI_myproc();
void PARTI_MPI_killall();
int PARTI_MPI_csend(int, char*, int, int);
int PARTI_MPI_crecv(int, char*, int, int);
int PARTI_MPI_isend(int, char*, int, int, MPI_Request*);
int PARTI_MPI_irecv(int, char*, int, int, MPI_Request*);
int PARTI_MPI_msgwait(MPI_Request*);
int PARTI_MPI_msgdone(MPI_Request*);
int PARTI_MPI_gsync();

#endif /* USE_MPI */

/*
 * PVM 3.1
 */
#ifdef USE_PVM
#include <pvm3.h>

#define GID_TYPE                           int
#define PARTI_setup(grp)                   PARTI_PVM_setup(grp)
#define PARTI_cleanup()                    PARTI_PVM_cleanup()
#define PARTI_numprocs()                   PARTI_PVM_numprocs()
#define PARTI_myproc()        	           PARTI_PVM_myproc()
#define PARTI_killall()                    PARTI_PVM_killall()
#define PARTI_csend(tag,buf,len,node)      PARTI_PVM_csend(tag,buf,len,node)
#define PARTI_crecv(tag,buf,len,node)      PARTI_PVM_crecv(tag,buf,len,node)
#define PARTI_isend(tag,buf,len,node,gid)  PARTI_PVM_csend(tag,buf,len,node)
#define PARTI_irecv(tag,buf,len,node,gid)  PARTI_PVM_crecv(tag,buf,len,node)
#define PARTI_msgdone(gid)                 1
#define PARTI_msgwait(gid)                 NULL
#define PARTI_gsync()                      PARTI_PVM_gsync()
#endif /* USE_PVM */

int PARTI_PVM_setup(char*);
void PARTI_PVM_cleanup();
int PARTI_PVM_numprocs();
int PARTI_PVM_myproc();
void PARTI_PVM_killall();
int PARTI_PVM_csend(int, char*, int, int);
int PARTI_PVM_crecv(int, char*, int, int);
int PARTI_PVM_gsync();

#endif /* PORT_H */
