/* 
 * Auth: Christian Hansen (chansen@cs.umd.edu)
 *       University of Maryland, College Park
 * Desc: Routines for creating communication schedules to
 *       send and receive ghost cell data.
 */

#ifndef SCHEDULES_H
#define SCHEDULES_H

#include "multiblockparti.h"

parti_region_t* copy_region(parti_region_t*);
void print_region(parti_region_t*);
int compute_stride(parti_darray_t*, int);
int compute_offset(parti_darray_t*, parti_region_t*);
void compute_recv(parti_sched_t*, parti_darray_t*, parti_region_t*);
void compute_send(parti_sched_t*, parti_darray_t*, parti_region_t*, int*);

#endif /* SCHEDULES_H */
