#include "utilities.h"

void elemset(char type, void* A, int value, int rank, int* size, int off, int dim) {
  int i, j = 1;

  if (!A)
    return;

  for (i = dim+1; i < rank; ++i)
    j *= size[i];
  
  for (i = 0; i < size[dim]; ++i) {
    if (dim == rank-1)
      switch (type) {
      case 'c':
	*((char*)A+off+i) = (char)value;
	break;
      case 'i':
	*((int*)A+off+i) = (int)value;
	break;
      case 'f':
	*((float*)A+off+i) = (float)value;
	break;
      case 'd':
	*((double*)A+off+i) = (double)value;
	break;
      }
    else
      elemset(type, A, value, rank, size, off+j*i, dim+1);
  }
}

void fprint_array(FILE* fp, char type, void* A, int rank, int* size, int off, int dim) {
  int i, j = 1;
  
  if (!A)
    return;
  
  for (i = dim+1; i < rank; ++i)
    j *= size[i];
  
  for (i = 0; i < size[dim]; ++i) {
    if (dim == rank-1)
      switch (type) {
      case 'c':
	fprintf(fp, "%3hd ", *((char*)A+off+i));
	break;
      case 'i':
	fprintf(fp, "%3d ", *((int*)A+off+i));
	break;
      case 'f':
	fprintf(fp, "%3.2f ", *((float*)A+off+i));
	break;
      case 'd':
	fprintf(fp, "%3.2lf ", *((double*)A+off+i));
	break;
      }
    else
      fprint_array(fp, type, A, rank, size, off+j*i, dim+1);
  }
  
  fprintf(fp, "\n");
}
