#include <mpi.h>
#include <stdio.h>
#include <bsparti.h>
#include "ctest.h"

int main(int argc, char* argv[]) {
  MPI_Comm GROUPCOMM;
  FILE* fp;
  char fn[80];
  int p, r;

  /* initialize MPI */
  MPI_Init(&argc, &argv);
  MPI_Comm_dup(MPI_COMM_WORLD, &GROUPCOMM);
  MPI_Comm_size(GROUPCOMM, &p);
  
  r = TIDCNT;
  if (p < r) {
    fprintf(stderr, "need %d tasks\n", r);
    return 1;
  }
  
  MPI_Barrier(GROUPCOMM);
  
  /* initialize MBP */
  PARTI_setup(&GROUPCOMM);
  
  /* run tests */
  MPI_Comm_rank(GROUPCOMM, &r);  

  sprintf(fn, "%s.out.%d", argv[0], r);
  if (fp = fopen(fn, "w")) {
    PARTI_test(fp, p, r);
    fclose(fp);
  }

  /* clean up */
  PARTI_cleanup();
  MPI_Barrier(GROUPCOMM);
  MPI_Comm_free(&GROUPCOMM);
  MPI_Finalize();
  return 0;
}
