c
c     print_array
c     
      subroutine print_array(A)      
      implicit none
      include 'ftest.h'

      integer A(LDIMX, LDIMY)
      integer i, j
      
      do i = 1, LDIMX
         print F1, (A(i,j), j = 1, LDIMY)
      end do
      end

c
c     partitest
c
      subroutine partitest(p, r)
      implicit none
      include 'ftest.h'
      include 'fbsparti.h'

      integer p, r
      integer i, j
      
c     vproc* equivalent
      integer vp
c     decomp* equivalent
      integer dc, sd
c     darray* equivalent
      integer da, sa
c     sched* equivalent
      integer sc
      
      integer ds(DIM)
      integer igl(DIM)
      integer igr(DIM)
      integer egl(DIM)
      integer egr(DIM)
      integer ef(DIM)
      integer dd(DIM)
      integer dt(DIM)

      integer local_sizes(DIM)
c      integer fill_vector(DIM)
      
      integer srce_dims(DIM)
      integer srce_lows(DIM)
      integer srce_highs(DIM)
      integer srce_strides(DIM)
      integer dest_dims(DIM)
      integer dest_lows(DIM)
      integer dest_highs(DIM)
      integer dest_strides(DIM)
      
c     no dynamic allocation for fortran, so local array sizes must be preset
      integer A(LDIMX, LDIMY)
      integer B(LDIMX, LDIMY)

c     set defaults
      ds(1) = DIMX
      ds(2) = DIMY
      igl(1) = ILX
      igl(2) = ILY
      igr(1) = IRX
      igr(2) = IRY
      egl(1) = ELX
      egl(2) = ELY
      egr(1) = ERX
      egr(2) = ERY
      ef(1) = 0
      ef(2) = 0
      dd(1) = 1
      dd(2) = 2
      dt(1) = 1
      dt(2) = 1

c     test array building functions
      call fvproc(vp, 1, p)
      call fdecomp(dc, DIM, ds)
      call fembed(dc, vp, 1, p)
      call fdistribute(dc, dt)
      da = ifalign(dc, DIM, ds,
     $     igl, igr,
     $     egl, egr, 
     $     ef, dd)
      call flasizes(da, local_sizes)
      print *, 'Local sizes:', local_sizes(1), ' x', local_sizes(2)
      do i = 1, LDIMX
         do j = 1, LDIMY
            A(i,j) = 100*r + 10*i + j
         end do
      end do
      
c     print, send internal ghost cells, and print again
      call sleep(r)
      print *, 'RANK:', r
      call print_array(A)
      print *, 'DIMX:', iflalbnd(da, 1, 1, 1), 
     $     ' ->', iflaubnd(da, 1, DIMX, 1)
      print *, 'DIMY:', iflalbnd(da, 2, 1, 1), 
     $     ' ->', iflaubnd(da, 2, DIMY, 1)
      sc = ifghostfillall_sched(da)
      call fidata_move(A, sc, A)
      call ffree_sched(sc)
      call sleep(r)
      print *, 'RANK:', r
      call print_array(A)
      
c     create second array
      call fdecomp(sd, DIM, ds)
      call fembed(sd, vp, 1, p)
      call fdistribute(sd, dt)
      sa = ifalign(sd, DIM, ds, igl, igr, egl, egr, ef, dd)
      do i = 1, LDIMX
         do j = 1, LDIMY
            B(i,j) = 100*r + 10*i + j
         end do
      end do
      
c     initialize settings for inter-array transfer */
      srce_dims(1) = 1
      srce_dims(2) = 2
      srce_lows(1) = 1
      srce_lows(2) = 1
      srce_highs(1) = 3
      srce_highs(2) = 3
      srce_strides(1) = 1
      srce_strides(2) = 1
      dest_dims(1) = 1
      dest_dims(2) = 2
      dest_lows(1) = 6
      dest_lows(2) = 6
      dest_highs(1) = 8
      dest_highs(2) = 8
      dest_strides(1) = 1
      dest_strides(2) = 1
      
      sc = ifsubarray_sched(sa, da, DIM,
     $     srce_dims, srce_lows, srce_highs, srce_strides,
     $     dest_dims, dest_lows, dest_highs, dest_strides)
      call fidata_move(A, sc, B)
      call ffree_sched(sc)
      call sleep(r)
      print *, 'RANK:', r
      call print_array(B)

      end
